//ltb.cs

datablock ParticleData(ltbSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 2.0;
	spinRandomMin		= -20.0;
	spinRandomMax		= 20.0;
	colors[0]     = "1.0 0.9 0.9 0.9";
	colors[1]     = "1.0 0.9 0.9 0.0";
	sizes[0]      = 0.18;
	sizes[1]      = 0.18;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ltbSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ltbSmokeParticle";

   uiName = "LEGO Tuskan Blaste Smoke";
};

datablock ParticleData(ltbTrailParticle)
{
	dragCoefficient		= 2.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 30;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	colors[0]	= "1 0.4 0.0 1.0";
	colors[1]	= "1 0.4 0.0 0.0";
	sizes[0]	= 0.13;
	sizes[1]	= 0.25;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(ltbTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = ltbTrailParticle;

   useEmitterColors = true;
   uiName = "LEGO Tuskan Blaster Trail";
};

datablock ParticleData(ltbExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 2.0;
	spinRandomMin		= -20.0;
	spinRandomMax		= 20.0;
	colors[0]     = "1.0 0.4 0.0 0.5";
	colors[1]     = "1.0 0.4 0.0 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.0;

	useInvAlpha = true;
};

datablock ParticleEmitterData(ltbExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ltbExplosionParticle";

   useEmitterColors = true;
   uiName = "LEGO Tuskan Blaster Explosion";
};

datablock ExplosionData(ltbExplosion)
{
   //explosionShape = "";
	soundProfile = lbsHitSound;

   lifeTimeMS = 150;

   particleEmitter = ltbExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 3;
   lightStartColor = "1 0.4 0 1";
   lightEndColor = "1 0.4 0 1";
};


AddDamageType("ltb",   '<bitmap:add-ons/Weapon_BasicLEGOblasters/CI_ltb> %1',    '%2 <bitmap:add-ons/Weapon_BasicLEGOblasters/CI_ltb> %1',0.2,1);
datablock ProjectileData(ltbProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 60;
   directDamageType    = $DamageType::ltb;
   radiusDamageType    = $DamageType::ltb;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 200;
   explosion           = ltbExplosion;
   particleEmitter     = ltbTrailEmitter;

   muzzleVelocity      = 140;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0.4 0.0 1";

   uiName = "LEGO Tuskan Blaster Laser";
};

//////////
// item //
//////////
datablock ItemData(ltbItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ltbi.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Tuskan Blaster";
	iconName = "./icon_ltb";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = ltbImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ltbImage)
{
   // Basic Item properties
   shapeFile = "./ltb.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ltbProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = ltbItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= llsShot1Sound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";

	stateName[4]			= "Smoke";
	stateSequence[4]                = "Smoke";
	stateTransitionOnTimeout[4]     = "Reload";
	stateTimeoutValue[4]            = 1.2;
	stateEmitter[4]					= ltbSmokeEmitter;
	stateEmitterTime[4]				= 1.2;
	stateEmitterNode[4]				= "muzzleNode";
	stateWaitForTimeout[4]			= true;

};

function ltbImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftup);
	Parent::onFire(%this,%obj,%slot);	
}

function ltbImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
        %obj.hidenode("LHand");
        %obj.hidenode("LHook");
        %obj.hidenode("RHook");
        %obj.unhidenode("RHand");
}
function ltbImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   
   %obj.unMountImage(1);
   if(isObject(%obj.client))
   {
      %obj.client.applyBodyParts();
      %obj.client.applyBodyColors();
   }
   else
   {
      %obj.unHideNode("lhand");
      %obj.unHideNode("lhook");
   }
   
   fixArmReady(%obj);
}